# RPGMod

This mod is highly configurable allowing you to have quests, adjustable interactable spawns, and heavily customisable enemy drops.

![Image of questing](https://i.imgur.com/Cd6a1np.png)

## Questing

This mod offers a networked questing system that is synced with others who have the mod installed, it can also be played with people without the mod if the host has the mod installed! Questing, UI and settings are highly customisable with the config.

## Enemy Item Drops

This mod has highly customisable enemy loot drops, with the ability to change the chances of each drop for each tier of enemy.

## Known Issues

This mod is WORK IN PROGRESS, meaning that there is a good chance that there are issues.

If you find any issues with my mod please create a new issue on the github, you can find existing issues here:
<https://github.com/ghasttear1/RPGMod/issues>

## Installation

1. Make sure BepInEx is installed correctly
2. Move the `RPGMod.dll` into `Risk of Rain 2\BepInEx\plugins` folder
3. Enjoy!

## Configuration

This mod has a large config with many values to change to your desire with the ability to reload on the go by pressing F6.

Steps on how to configure:

1. Navigate to the `Risk of Rain 2\BepInEx\plugins` folder
2. Open the `com.ghasttear1.rpgmod.cfg` file using your preferred text editor
3. Edit the values that you wish to edit following the formatting specified (if unfamiliar with common data types such as float or boolean, a quick google search will help out)
4. Importantly, save the file then if ingame press F6 to recieve the changes, otherwise starting the game normally will load the new values.
5. Enjoy!

## Updating

When updating please delete your old config for the mod and let a new one get created (you can make a backup of the old one and copy old values over), as config descriptions and values get added and changed with most updates.

## Changelog

```text
- 1.0.0: Mod release!
- 1.0.1: Updated readme
- 1.0.2: Fixed glitched first quest
- 1.0.3: Fixed teleporter getting stuck, changed config reload to F6 (conflict with ROR2Cheats), added config types, fixed item drop spam, added new config for quest resetting on advancing stage, special thanks to @Targets for help debugging :)
- 1.0.4: Removed debugging messages that were left in
- 1.0.5: Small amount of code cleanup, fixed vertical UI bug and large UI bug, fixed disabling enemydrops making quest progress not work, fixed item spam when player dies or leaves, fixed moving from singleplayer game to multiplayer game, and more
- 1.1.0: Added game scaling for drops helping even out drops experienced at early and end game, added chat message for help with those playing with unmodded players, changed the way the scene placement works making disabled spawns configurable, changed config defaults, descriptions and values
- 1.1.1: Fixed the broken display caused from the latest game update
- 1.1.2: Fixed the possibility of enemy survivors been chosen for a quest target
- 1.2.0: Fixed mod to work with latest update - (had to remove chest drops from bosses as a configurable option as it broke)
- 1.2.1: Reimplemented a fix that was previously in the mod hopefully fixing a problem with quests and particular enemies
- 1.2.2: Fixed problem with multiple drops from a quest
- 1.2.3: Fixed issue where depending on the computers localisation the config values would improperly be loaded
- 1.2.4: Engineer turrets now count towards kills thanks @iDeathHD, quests no longer stop counting progress.
- 1.2.5: No longer any turret issues with other mods modifying turrets, fixed items no longer dropping after some time. (IMPORTANT UPDATE)
```

## Contact

You can find me on the modding discord, I'm new to modding but I will try my best to answer any questions.
